/********************************************************************************************
(C) Jakub Borzdynski 2009
jotbeage@interia.pl
-----------------------------
Szkola Konstruktorow 156
Przelacznik AV
-----------------------------
Program glowny
********************************************************************************************/
#define sbi(port, bit) port|=(1<<bit)
#define cbi(port, bit) port&=~(1<<bit)
#define F_CPU 3686400UL

#include <avr/io.h> //definicje rejestrow uK
#include <avr/signal.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "src/device.h"
#include "src/eeprom.h"
#include "src/btm222.h"

SIGNAL(SIG_USART0_RECV){
	btm.interrupt() ;
}

int main(){
	bool stat = 0 ;
	dev.statusLed(1) ;
	
	//detekcja przytrzymania przycisku
	while(1){
		//obsluga klawiatury
		char result = dev.key() ;
		if(result&DEVICE_KEY_1){dev.relayInvert(DEVICE_RELAY_1) ;}
		if(result&DEVICE_KEY_2){dev.relayInvert(DEVICE_RELAY_2) ;}
		if(result&DEVICE_KEY_3){dev.relayInvert(DEVICE_RELAY_3) ;}  
		if(result&DEVICE_KEY_4){dev.relayInvert(DEVICE_RELAY_4) ;}
		
		//nacisnieto jakis klawisz  ?
		if(result!=0){
			btm.writeChar(dev.getRelayState()|0xB0);  //przeslij zmiane do urzadzenia
		}
		
		//sprawdzenie, czy nadszedl nowy znak
		if(btm.isNewData()){
			char data = btm.readChar() ; //odebrany znak
			unsigned char index = (data&0x0F)*22 ; //adres pamieci
			
			//"uklad" decyzyjny
			switch(data&0xF0){
				case 0xA0: //ustawienie stanu przekaznikow
					dev.setRelayState(data&0x0F)  ;
					break ;
				case 0xB0: //prosba o wyslanie stanu przekaznikow
					btm.writeChar(dev.getRelayState()|0xB0);
					break ;
				case 0xC0: //prosba o przeslanie nazwy urzadzenia
					//odeslij nazwe urzadzenia
					btm.writeChar(data) ; //kod polecenia
					
					//przeslanie nazwy
					for(unsigned char i=0 ; i<22 ; i++){
						char znak = memory.read(index+i) ;
						btm.writeChar(znak) ; //kod polecenia
						if(znak==0){break;}
					}
					break ; 
				case 0xD0:
					//oczekuj na zakonczenie transmisji
					_delay_ms(20) ;
					
					//pobierz bajty i zapisz w pamieci
					while(btm.isNewData()){
						char temp = btm.readChar() ;
						memory.write(index++, temp)  ;
						if(temp==0){break;}
					}
					
					break ;
				case 0xE0:
					
					break ;
				case 0xF0:
					stat = !stat ;
					dev.statusLed(stat) ;
					break ;
			}
		}
	}
}



