/********************************************************************************************
(C) Jakub Borzdynski 2009
jotbeage@interia.pl
-----------------------------

********************************************************************************************/
//definicje
#define F_CPU 1000000UL

#ifndef jb_device_cpp
#define jb_device_cpp
#include "device.h"

//zmienne pomocnicze
bool key1=false, key2=false, key3=false, key4=false ;

//konstruktor
device::device(){
	//konfiguracja przekaznikow
	DDRB |= 0x0F ; //ustaw porty przekaznikow
	PORTB &= 0xF0 ; //wylacz przekazniki
	
	//konfiguracja diody statusowej
	sbi(DDRD, 6);
	cbi(PORTD,6);
	
	//konfigurowanie portow wejsciowych
	DDRB  &= 0x0F ; //ustaw jako wejscia
	PORTB |= 0xF0 ; //wlacz podciaganie
}

//pobiera stany przekaznikow
char device::getRelayState(){
	//zmienne
	char maska = 0 ;
	
	//sprawdzenie poszczegolnych portow
	if(PORTB&DEVICE_RELAY_1){maska|=0x01;}
	if(PORTB&DEVICE_RELAY_2){maska|=0x02;}
	if(PORTB&DEVICE_RELAY_3){maska|=0x04;}
	if(PORTB&DEVICE_RELAY_4){maska|=0x08;}
	
	//zwroc rezultat
	return maska ;
}

//wlacza wybrane diody LED
void device::setRelayState(char maska){
	if(maska&0x01){PORTB|=DEVICE_RELAY_1;}else{PORTB&=~DEVICE_RELAY_1;}
	if(maska&0x02){PORTB|=DEVICE_RELAY_2;}else{PORTB&=~DEVICE_RELAY_2;}
	if(maska&0x04){PORTB|=DEVICE_RELAY_3;}else{PORTB&=~DEVICE_RELAY_3;}
	if(maska&0x08){PORTB|=DEVICE_RELAY_4;}else{PORTB&=~DEVICE_RELAY_4;}
}

//przelacza stan przekaznika
void device::relayInvert(char maska){
	PORTB ^= maska ;
}

//wl/wyl statusowa diode LED
void device::statusLed(bool stan){
	if(stan){
		sbi(PORTD, 6) ;
	}else{
		cbi(PORTD, 6) ;
	}
}

//zwraca wartosc maski
char device::key(){
	char result = 0 ;
	
	//przycisk 1
	if(!(PINB&DEVICE_KEY_1)){
		_delay_ms(20) ;
		if( !(PINB&DEVICE_KEY_1) && (key1==false) ){
			key1 = true ;
			result |= DEVICE_KEY_1;
		}
	}else{
		key1 = false ;
	}
	
	//przycisk 2
	if(!(PINB&DEVICE_KEY_2)){
		_delay_ms(20) ;
		if( !(PINB&DEVICE_KEY_2) && (key2==false) ){
			key2 = true ;
			result |= DEVICE_KEY_2;
		}
	}else{
		key2 = false ;
	}
	
	//przycisk 3
	if(!(PINB&DEVICE_KEY_3)){
		_delay_ms(20) ;
		if( !(PINB&DEVICE_KEY_3) && (key3==false) ){
			key3 = true ;
			result |= DEVICE_KEY_3;
		}
	}else{
		key3 = false ;
	}
	
	//przycisk 4
	if(!(PINB&DEVICE_KEY_4)){
		_delay_ms(20) ;
		if( (!(PINB&DEVICE_KEY_4)) && (key4==false) ){
			key4 = true ;
			result |= DEVICE_KEY_4;
		}
	}else{
		key4 = false ;
	}
	
	//zwroc rezultat
	return result;
}

device dev ;

#endif